-- Copyright (C) 1987 G|ran Uddeborg
--
-- This file is part of FPG.
--
-- FPG is distributed in the hope that it will be useful, but WITHOUT ANY
-- WARRANTY.  No author or distributor accepts responsibility to anyone for
-- the consequences of using it or for whether it serves any particular
-- purpose or works at all, unless he says so in writing.  Refer to the FPG
-- General Public License for full details.
--
-- Everyone is granted permission to copy, modify and redistribute FPG, but
-- only under the conditions described in the FPG General Public License.
-- A copy of this license is supposed to have been given to you along with
-- FPG so you can know your rights and responsibilities.  It should be in a
-- file named COPYING.  Among other things, the copyright notice and this
-- notice must be preserved on all copies.

module

export Module, Binding, Expr;

-- The types in this module describe a program.  Only the constructions
-- actually used by the parser generator can be described.
rec
type
    Module =
    	MkModule
		(List (List Char))
		(List (List Char))
		(List (List Char))
		Binding
and type
    Binding =
    	Funb (Expr#Expr) +
    	Type (List Char) (List (List Char)) (List Expr) +
	And (List Binding) +
	Rec Binding +
    	Local Binding Binding
and type
    Expr =
    	Aexp (List Char) +   	-- Atomic, that is unpartable, expression
	Case Expr (List (Expr#Expr)) +
	Let Binding Expr +
	Lambda Expr Expr +
	App (List Expr) +
	Tuple (List Expr)

end
