module
#include <OK>
export parsecode;
rec	parsecode file = 
	    case openfile file in
		No emsg : fail file
	    ||	Yes file : 
		    map parseline (choplist (splitat '\n') file)

	    end

and	parseline [] = (0,0,0,0,[false;false;false])
||	parseline line = 
	  let [Adr;Imed;Rreg;Wreg;Jadr;Jcond] = choplist takeword line
	  in mkimed Imed, mkrreg Rreg, mkwreg Wreg, stoi Jadr,mkcond Jcond

and	mkcond "Never" = [false;false;false] 
||	mkcond "Always" = [true;true;true]
||	mkcond "Zero" = [false;true;false]
||	mkcond "Equal" = [true;false;false]

and	 pindex a b = let r = index a b
		      in if r = -1 then stoi (hd a) else r

and	mkrreg reg = pindex [reg] ["Alur";"Imed";"R0";"R1";"R2"]
		     
and	mkwreg reg = 
		pindex [reg] ["Alura";"Alurb";"R0";"R1";"R2";"Output";"Alufr"]

and	mkimed imed =
		if (hd imed) = '_' then
			ord (hd (tl imed))
		else
			pindex [imed] ["Plus";"Minus";"And";"Or";"Xor"]
end
	

