#include "stream.t"
#include "sim.t"
#include "timing.t"
#include "gates.t"
#include "flipflops.t"
let rec
	Reset = false::false::false::false::St
and	Xclk = Oscft 15 15
and	Xdir = Oscft 150 150

and	Xor1 = gxor Xclk St
and	Xor2 = gxor Xdir D1qi
and	(D1q,D1qi) = dflop St Reset Xor1 D1qi
and	(D2q,D2qi) = dflop St Reset Xclk Xor2
and	X2 = D1q
and	X1 = D2q
in	timing [Xclk;Xdir;X1;X2;Reset] 
	       ["Xclk";"Xdir";"X1";"X2";"Reset"] 
	       [] [[]] Xclk (stoi (hd argv))

