module
#include "../misc/misc.t"
#include "../expr/id.t.t"
#include "../expr/id.t"
#include "../Expr/Expr.t.t"
#include "lliftutil.t"
#include "../misc/setofid.t"
#include "../misc/util.t"

export lambdalift;

lambdalift (Emodule i exl dss) u =
   (let (dss', u') = Umap lift1 dss u
   in (Emodule i exl dss', u'))

where lift1 dl unique =
   let Xset sol s z = itlist(\f.\p.Iu (assocdefeq eqid f sol []) p) s z 
   in
   let rec 
   	   Le (Elet r d e) vars funs sol u =
		let rec (ed,dd,id,dvars,dfuns,ss,ud) = Ld d nvars nfuns nsol u
		    and (ee,de,ie,ue) = Le e nvars nfuns nsol ud
		    and nvars = Iu vars dvars
	            and nfuns = Iu funs dfuns
		    and nsol = 	if r then -- if recursive let
		    	       	    solve(map(\(f,S).
			        	    f,
					    Xset sol (Is S funs) (Is S nvars),
					    Is S dfuns)
					    ss) @ sol
				else
				    -- map(\(f,S).(f, Is S vars)) ss @ sol
				    map(\(f,S).(f, Xset sol (Is S funs) 
				    		        (Is S vars))) ss @ sol
		in (case ed in []:ee || _._: Elet r ed ee end,
			    dd@de, Iu id ie, ue)
	|| Le (Eidapl f E) vars funs sol u =
		let! (eE,dE,iE,uE) = La E vars funs sol u
		in (Eidapl f (map idexp (assocdefeq eqid f sol []) @ eE),
		    dE, Iu [f] iE, uE)
	|| Le (Elamapl I e E) vars funs sol u =
/*		let iu = numid u in
		Le (Elet false [iu,Elamapl I e []] (Eidapl(iu,E)))
		   vars funs sol (u+1)
*/
	        let! (ee,de,ie,ue) = Le e (Iu vars (Imk I)) funs sol (u+1)  in
		let! (eE,dE,iE,uE) = La E vars funs sol ue   in
		let iu = numid u in
		let Ifree = Xset sol (Is funs ie) (Is vars ie) in
		   (Eidapl iu (map idexp Ifree @ eE), 
		    (iu, Elamapl (Ifree @ I) ee []).de@dE,
		    Iu ie iE, uE)

	|| Le (Econstr c E) vars funs sol u = 
		let! (eE,dE,iE,uE) = La E vars funs sol u
		in (Econstr c eE, dE, iE, uE)
	|| Le (Einfo f e) vars funs sol u =
	        let! (ee,de,ie,ue) = Le e vars funs sol u
		in (Einfo f ee, de, ie, ue)

	|| Le (Ecase e p f) vars funs sol u =
		let rec Lp [] vars funs sol u = ([], [], [], u)
		     || Lp ((c,I,e).p) vars funs sol u =
		        let! (ee,de,ie,ue) = Le e (Iu(Imk I)vars) funs sol u in
		        let! (ep,dp,ip,up) = Lp p vars funs sol ue in
			   ((c,I,ee).ep, de@dp, Iu ie ip, up)
		in
	        let! (ee,de,ie,ue) = Le e vars funs sol u  in
	        let! (ep,dp,ip,up) = Lp p vars funs sol ue in
	        let! (ef,df,id,uf) = Le f vars funs sol up in
		   (Ecase ee ep ef, de@dp@df, Iu (Iu ie ip) id, uf)

	|| Le (Efailmatch n) vars fun sol u =
		(Efailmatch n, [], [], u)
	

       and La   []  vars funs sol u = ([], [], [], u)
	|| La (e.l) vars funs sol u = 
		     let! (ee,de,ie,ue) = Le e vars funs sol u  in
		     let! (el,dl,il,ua) = La l vars funs sol ue
		     in (ee.el, de@dl, Iu ie il, ua)

       and Ld [] vars funs sol u = ([], [], [], [], [], [], u)
	|| Ld ((f, (Elamapl (I as _._) e [])).l) vars funs sol u =
		     let! (ee,de,ie,ue) = Le e (Iu vars (Imk I)) funs sol u in
		     let! (el,dl,il,dvars,dfuns,ss,ud) = Ld l vars funs sol ue
		     in (el, (f,Elamapl (assocdefeq eqid f sol [] @ I) ee []).de@dl,
		        Iu ie il, dvars, Iu [f] dfuns, (f, ie).ss, ud)
	|| Ld ((x,e).l) vars funs sol u =
	       	     let! (ee,de,ie,ue) = Le e vars funs sol u  in
		     let! (el,dl,il,dvars,dfuns,ss,ul) = Ld l vars funs sol ue
		     in ((x,ee).el, de@dl, Iu ie il, 
		         Iu [x] dvars, dfuns, ss, ul)

    in 
    let rec Ldtop [] u = ([], u)
	 || Ldtop ((f,Elamapl I e []).l) u =
		     let! (ee,de,ie,ue) = Le e (Imk I) [] [] u  in
		     let! (el,ul) = Ldtop l ue  in
			((f,Elamapl I ee []).de@el, ul)
    in
    let (liftedfundefs, newunique) = Ldtop dl unique
    in (liftedfundefs, newunique)
end
