module -- mtrans
--
--
#include "../mcode/mcodedef.t.t"
#include "../mcode/mutil1.t"
#include "tmp.h"
export mtrans2;
rec

    ftmp1 0 = dtmp1
||  ftmp1 1 = dtmp2
||  ftmp1 2 = dtmp3
and ftmp2 0 = dtmp2
||  ftmp2 1 = dtmp3
||  ftmp2 2 = dtmp1
and ftmp3 0 = dtmp3
||  ftmp3 1 = dtmp1
||  ftmp3 2 = dtmp2

and small n = n <= 4095 & n >= -4096
and rc add (const n) = small n
||  rc sub (const n) = small n
||  rc _   (reg _)   = true
||  rc _   _         = false
and op31 n op a1 a2 a3 & (rc op a1) = op32 n op a1 a2 a3
||  op31 n op a1 a2 a3 = Mmove a1 (ftmp1 n) . op32 n op (ftmp1 n) a2 a3
and op32 n (op as sub) a1 (a2 as const 0) a3 = op33 n op a1 a2 a3
||  op32 n op a1 (a2 as reg _) a3 = op33 n op a1 a2 a3
||  op32 n op a1 a2 a3 = Mmove a2 (ftmp2 n) . op33 n op a1 (ftmp2 n) a3
and op33 n op a1 a2 (a3 as reg _) = [Mop3 op a1 a2 a3]
||  op33 n op a1 a2 a3 = [Mop3 op a1 a2 (ftmp3 n); Mmove (ftmp3 n) a3]

-- Insert temp regs.
and mr n (Mmove (retaddr s) a2) = [Mmove (reg Ret) a2; Mmove (idlit (s@"-8")) (reg Ret)]
||  mr n (m as Mmove (reg _) _) = [m]
||  mr n (m as Mmove _ (reg _)) = [m]
||  mr n (Mmove a1 a2) = [Mmove a1 (ftmp1 n); Mmove (ftmp1 n) a2]
||  mr n (m as Mcompare (reg _) (reg _)) = [m]
||  mr n (m as Mcompare (reg _) (const _)) = [m]
||  mr n (Mcompare a1 a2) & (rc add a1) = [Mmove a2 (ftmp2 n); Mcompare a1 (ftmp2 n)]
||  mr n (Mcompare a1 a2) & (rc add a2) = [Mmove a1 (ftmp1 n); Mcompare (ftmp1 n) a2]
||  mr n (Mcompare a1 a2) = [Mmove a1 (ftmp1 n); Mmove a2 (ftmp2 n); Mcompare (ftmp1 n) (ftmp2 n)]
||  mr n (m as Mop2 op _ _) & (op = mul | op = div | op = mod) = [m]
||  mr n (m as Mop2 op a1 (reg _)) & (rc op a1) = [m]
||  mr n (Mop2 op a1 a2) & (rc op a1) =
	[Mmove a2 (ftmp2 n); Mop2 op a1 (ftmp2 n); Mmove (ftmp2 n) a2]
||  mr n (Mop2 op a1 (a2 as reg _)) = 
	[Mmove a1 (ftmp1 n); Mop2 op (ftmp1 n) a2]
||  mr n (Mop2 op a1 a2) = 
	[Mmove a1 (ftmp1 n); Mmove a2 (ftmp2 n); Mop2 op (ftmp1 n) (ftmp2 n); Mmove (ftmp2 n) a2]

||  mr n (m as Mop3 op _ _ _) & (op = mul | op = div | op = mod) = [m]
||  mr n (Mop3 op a1 a2 a3) = op31 n op a1 a2 a3

||  mr n (m as Mcase (reg _) x1 x2 x3 x4 x5) = [m]
||  mr n (m as Mboolcc cc (reg _)) = [m]
||  mr n (Mboolcc cc a) = [Mboolcc cc (ftmp1 n); Mmove (ftmp1 n) a]
||  mr n m = [m]

and mt (Mmove (regrel r1 0) (reg r2)) & (r1=r2) = 
	[]
||  mt (Mmove (regrel r1 0) (reg r2)) = 
	[Mmove (reg r1) (reg r2)]
||  mt (Mmove (regrel r1 n) (reg r2)) & (r1=r2) = 
	[Mop2 add (const (4*n)) (reg r1)]
||  mt (Mmove (regrel r1 n) (reg r2)) = 
	[Mop3 add (const (4*n)) (reg r1) (reg r2)]
||  mt m = [m]
and mm (Mcompare (glob "_ehp") a2) = Mcompare (reg Ehpr) a2
||  mm (Mcompare a1 (glob "_ehp")) = Mcompare a1 (reg Ehpr)
||  mm m = m
and mtrans2 ms = concmap mt (concmap2 mr (let rec l = 0 . 1 . 2 . l in l) (map mm ms))

and concmap2 f (x1.l1) (x2.l2) = f x1 x2 @ concmap2 f l1 l2
||  concmap2 f _ _ = []
end
